<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- 
IGAC proyecto SNC
@author 		javier.aponte
@version 		1.0
@description	Pantalla que muestra el formulario para consultar por datos de persona
@cu 			CU-TV-PR-002
@param			managedBeanParam: 		Nombre del ManagedBean del que se obtendran los parametros
modificado por leidy.gonzalez	Se agregan Notas de ejemplo para la carga de archivo masivo por persona
@modified by leidy.gonzalez Se elimina la lectura de archivos .xls, solo se deja para archivos tipo .xlsx
-->

<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:fn="http://java.sun.com/jsp/jstl/functions"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:p="http://primefaces.org/ui" 
        id="consultarPorDatosPersonaForm">

    <h:inputText id="errortFocus" style="border:0px;height:0;" />

    <p:messages id="msgsConsultarPorDatosPersona" showDetail="false" globalOnly="false" />

    <p:spacer width="0" height="13" />

    <h:panelGrid columns="2" width="100%">

        <h:outputLabel value="Descripción producto"
                       styleClass="outputLabelStyle"/>
        <h:outputText value="#{managedBeanParam.productoCatastralSeleccionado.producto.nombre}"
                      styleClass="outputTextStyle" id="SolicitudTipoV"/>

    </h:panelGrid>

    <p:spacer height="10" width="0" />

    <p:fieldset toggleable="true" toggleSpeed="500"
                id="personaFS" >
        <legend>
            <h:outputText value="Personas"
                          styleClass="legendTitle" />
        </legend>

        <p:fieldset toggleable="true" toggleSpeed="500"
                    id="tipoSeleccion" rendered="#{!managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}">
            <h:outputText value="Tipo de selección " />  
            <h:selectOneRadio id="options" value="#{managedBeanParam.tipoDeSeleccionConsultaPersona}">  
                <f:selectItem itemLabel="Individual" itemValue="1" /> 
                <f:selectItem itemLabel="Masivo" itemValue="2" />
                <p:ajax update="personaFS" process="@this"/>  
            </h:selectOneRadio>

        </p:fieldset>

        <p:spacer height="10" width="0"/>

        <h:panelGrid columns="2" rendered="#{managedBeanParam.tipoDeSeleccionConsultaPersona eq '1'}">

            <p:fieldset toggleable="true" toggleSpeed="500"
                        rendered="#{!managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}"
                        id="identificacionPersonaFS">
                <legend>
                    <h:outputText value="Identificación persona"
                                  styleClass="legendTitle" />
                </legend>

                <h:panelGrid columns="2" id="identificacionPersonaPanel">
                    <h:panelGrid columns="2">
                        <h:outputLabel value="Tipo de persona:"	styleClass="outputLabelStyle" />
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                    </h:panelGrid>

                    <h:selectOneMenu
                        id="tipoPersona"
                        label="Tipo de persona" value="#{managedBeanParam.nuevoProductoCatastralDetalle.tipoPersona}"
                        required="true" >
                        <f:selectItems value="#{general.personaTipoPersonaV2}" />
                        <p:ajax process="@this" event="change" listener="#{managedBeanParam.tipoPersonaSel}"
                                onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" 
                                update="personaFS"/>
                    </h:selectOneMenu>

                    <h:panelGrid columns="2">
                        <h:outputLabel value="Tipo de documento:"
                                       styleClass="outputLabelStyle" />
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                    </h:panelGrid>

                    <h:selectOneMenu
                        id="tipoDocumento"
                        label="Tipo de documento" required="true"
                        value="#{managedBeanParam.nuevoProductoCatastralDetalle.tipoIdentificacion}"
                        rendered="#{managedBeanParam.nuevoProductoCatastralDetalle.personaNatural}">
                        <f:selectItems value="#{general.personaTipoIdentificacionNoNitV}" />
                        <p:ajax process="@this" event="change" update="identificacionPersonaPanel"
                                onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" />
                    </h:selectOneMenu>

                    <h:outputText
                        value="#{managedBeanParam.nuevoProductoCatastralDetalle.tipoIdentificacion}"
                        id="PersonaTipoIdentificacionV" styleClass="outputTextStyle"
                        rendered="#{!managedBeanParam.nuevoProductoCatastralDetalle.personaNatural}">
                        <f:converter converterId="converterCB"
                                     for="PersonaTipoIdentificacionV" />
                    </h:outputText>

                    <h:panelGrid columns="2">
                        <h:outputLabel value="Número identificación: "
                                       styleClass="outputLabelStyle" />
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                    </h:panelGrid>

                    <h:inputText id="numeroIdentificacion"
                                 value="#{managedBeanParam.nuevoProductoCatastralDetalle.numeroIdentificacion}"
                                 label="Número identificación" size="30" required="true" >
                        <f:validateLength maximum="50"/>
                    </h:inputText>

                    <h:panelGrid columns="2" rendered="#{managedBeanParam.nuevoProductoCatastralDetalle.esNIT}">
                        <h:outputLabel value="DV: "
                                       styleClass="outputLabelStyle" />
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                    </h:panelGrid>

                    <h:inputText id="digitoVerificacion"
                                 rendered="#{managedBeanParam.nuevoProductoCatastralDetalle.esNIT}"
                                 value="#{managedBeanParam.nuevoProductoCatastralDetalle.digitoVerificacion}"
                                 label="Dígito verificacion" size="2" required="true">
                        <f:validateLength maximum="2"/>
                    </h:inputText>

                </h:panelGrid>

            </p:fieldset>

            <p:spacer height="10" width="0"/>

            <p:fieldset toggleable="true" toggleSpeed="500"
                        id="personaNaturalFS"
                        rendered="#{managedBeanParam.nuevoProductoCatastralDetalle.personaNatural
                                    and managedBeanParam.activarSeccionPersonaNatural and !managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}">
                <legend>
                    <h:outputText value="Persona natural"
                                  styleClass="legendTitle" />
                </legend>

                <h:panelGrid columns="2" id="personaNaturalPanel"
                             cellspacing="7">

                    <h:panelGrid columns="2">
                        <h:outputLabel value="Primer apellido: "
                                       styleClass="outputLabelStyle" />
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                    </h:panelGrid>

                    <h:inputText id="primerApellido" required="true"
                                 value="#{managedBeanParam.nuevoProductoCatastralDetalle.primerApellido}"
                                 label="Primer apellido" >
                        <f:validateLength maximum="100"/>
                    </h:inputText>

                    <h:outputLabel value="Segundo apellido: "
                                   styleClass="outputLabelStyle" />
                    <h:inputText id="segundoApellido"
                                 value="#{managedBeanParam.nuevoProductoCatastralDetalle.segundoApellido}"
                                 label="Segundo apellido" >
                        <f:validateLength maximum="100"/>
                    </h:inputText>

                    <h:panelGrid columns="2">
                        <h:outputLabel value="Primer nombre: "
                                       styleClass="outputLabelStyle" />
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                    </h:panelGrid>
                    <h:inputText id="primerNombre" required="true"
                                 value="#{managedBeanParam.nuevoProductoCatastralDetalle.primerNombre}"
                                 label="Primer nombre" >
                        <f:validateLength maximum="100"/>
                    </h:inputText>	

                    <h:outputLabel value="Segundo nombre: "
                                   styleClass="outputLabelStyle" />
                    <h:inputText id="segundoNombre"
                                 value="#{managedBeanParam.nuevoProductoCatastralDetalle.segundoNombre}"
                                 label="Segundo nombre" >
                        <f:validateLength maximum="100"/>
                    </h:inputText>

                </h:panelGrid>

            </p:fieldset>



            <p:fieldset toggleable="true" toggleSpeed="500"
                        id="personaJuridicaFS"
                        rendered="#{managedBeanParam.nuevoProductoCatastralDetalle.personaJuridica
                                    and managedBeanParam.activarSeccionPersonaJuridica and !managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}">
                <legend>
                    <h:outputText value="Persona juridica"
                                  styleClass="legendTitle" />
                </legend>

                <h:panelGrid columns="2" id="personaJuridicaPanel"	cellspacing="7">

                    <h:panelGrid columns="2">
                        <h:outputLabel value="Razón social: "
                                       styleClass="outputLabelStyle" />
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                    </h:panelGrid>

                    <h:inputText id="razonS" required="true"
                                 value="#{managedBeanParam.nuevoProductoCatastralDetalle.razonSocial}"
                                 size="40" label="Razón social" >
                        <f:validateLength maximum="100"/>
                    </h:inputText>

                    <h:outputLabel value="Sigla: "
                                   styleClass="outputLabelStyle" />
                    <h:inputText id="sigla"
                                 value="#{managedBeanParam.nuevoProductoCatastralDetalle.sigla}"
                                 size="10" label="Sigla" >
                        <f:validateLength maximum="50"/>
                    </h:inputText>

                </h:panelGrid>

            </p:fieldset>

        </h:panelGrid>

        <h:panelGrid columns="3" rendered="#{managedBeanParam.tipoDeSeleccionConsultaPersona eq '2'}"
                     id="personaMasivo">

            <h:panelGrid columns="2" >
                <h:outputLabel value="Masivo:" styleClass="outputLabelStyle"
                               id="personaMasivoLabel" />
                <h:outputLabel value="*" styleClass="requiredLabelStyle" />
            </h:panelGrid>

            <p:spacer height="20" width="0"/>
            <h:panelGrid columns="1" cellspacing="3" width="100%">
                <p:spacer width="0" height="10" />

                <h:outputLabel value="Nota:" styleClass="noteLabelStyle" />
                <h:outputText
                    value="El archivo masivo debe tener extensión .txt  separado por punto y coma, ó .xlsx separado en celdas."
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="El archivo masivo debe tener la estructura ordenada: Tipo de Persona, Tipo Identificación, No. Identificación, DV, Primer Apellido, Segundo Apellido, Primer Nombre, Segundo Nombre, Razón Social y Sigla."
                    styleClass="noteTextStyle" />

                <p:spacer width="0" height="13" />

                <h:outputText
                    value="Ejemplo:"
                    styleClass="noteTextStyle" />

                <h:outputText
                    value="*Tipo persona: NATURAL, JURIDICA (Longitud maxima: 30 Caracteres)"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="*Tipo identificación: CC, CE, CM, LM, NIT, X, PA, RC, TI (Longitud maxima: 30 Caracteres)
                    "
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="*No. Identificación: 123 (Longitud maxima: 50 Caracteres)"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="*DV: 1(Longitud maxima: 2 Caracteres)"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="	*Primer Apellido: Primer Apellido (Longitud maxima: 100 Caracteres)"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="*Segundo Apellido: Segundo Apellido (Longitud maxima: 100 Caracteres)"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="*Primer Nombre: Primer Nombre (Longitud maxima: 100 Caracteres)"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="*Segundo Nombre: Segundo Nombre (Longitud maxima: 100 Caracteres)"
                    styleClass="noteTextStyle" />

                <h:outputText
                    value="*Razón social: Razón Social (Longitud maxima: 100 Caracteres)"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="*Sigla: Sigla (Longitud maxima: 50 Caracteres)"
                    styleClass="noteTextStyle" />

                <p:spacer width="0" height="13" />

                <h:outputText
                    value="Ejemplo con Datos Excel: 	NATURAL	-	CC - 6045655 - 		AZSIR - OMRUKEO - ZILUMIZ - URUIRTO"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="	Ejemplo con Datos Excel:	JURIDICA - NIT - 623218274 - 1				-					PARTILOZ ERVIMAZ Z I	- 	PEZI"
                    styleClass="noteTextStyle" />

                <p:spacer width="0" height="13" />

                <h:outputText
                    value="Ejemplo con Datos Texto: NATURAL;  CC;  6045655;  AZSIR; OMRUKEO; ZILUMIZ; URUIRTO"
                    styleClass="noteTextStyle" />

                <h:outputText
                    value=" Ejemplo con Datos Texto: JURIDICA; NIT; 8223038882;	;UMBORZUAMOZ JETUORROS TUMASA Y SU; ;"
                    styleClass="noteTextStyle" />

                <p:spacer width="0" height="13" />

                <h:outputText
                    value="Observación: "
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="La columna 3 ó número de identificación antes de ser ingresados los valores es indispensable que sea ajustada a formato texto."
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="Para Tipo persona NATURAL, los campos obligatorios son: Tipo identificación, No. Identificación, Primer Apellido,Segundo Apellido,Primer Nombre y Segundo Nombre"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="Para Tipo persona JURIDICA, los campos obligatorios son: Tipo identificación, No. Identificación, DV, Razón social y Sigla"
                    styleClass="noteTextStyle" />
                <h:outputText
                    value="Los campos obligatorios no pueden ser nulos para cada TIPO DE PERSONA: si no existe debe dejar el campo con comilla sencilla espacio comilla sencilla para los archivos .xlsx ó el campo en blanco separado por ; para los archivos .txt"
                    styleClass="noteTextStyle" />

                <p:spacer height="0" width="30" />
                <p:fileUpload id="fus"
                              fileUploadListener="#{managedBeanParam.validadorArchivoPersona}" required="true"
                              dragDropSupport="true"
                              invalidFileMessage="El tipo de archivo seleccionado no es valido"
                              label="Cargar archivo" auto="true"
                              invalidSizeMessage="El archivo seleccionado supera el tamaño permitido"
                              mode="advanced" sizeLimit="#{general.maximoTamanoAdjuntos}"
                              allowTypes="/(\.|\/)(xls|txt|xlsx?)$/"
                              update="fus,panelDocSop, msgsConsultarPorDatosPersona"
                              onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();" />
                <p:spacer height="25" width="30" />
                <h:panelGrid columns="2" cellspacing="7" id="panelDocSop">
                    <h:outputLabel value="Documento de bloqueo masivo: "
                                   rendered="#{ not empty managedBeanParam.nombreDocumentoProductoMasivo}"
                                   styleClass="outputLabelStyle" />

                    <p:commandLink id="downloadLink" styleClass="commandLinkStyle"
                                   value="#{managedBeanParam.nombreDocumentoProductoMasivo}" ajax="false"
                                   process="@this"
                                   rendered="#{ not empty managedBeanParam.nombreDocumentoProductoMasivo}">
                        <f:setPropertyActionListener
                            target="#{managedBeanParam.documentoTemporalAVisualizar}"
                            value="#{managedBeanParam.documentoTemporalProductoMasivo}" />
                        <p:fileDownload value="#{managedBeanParam.fileTempDownload}" />
                    </p:commandLink>

                </h:panelGrid>

            </h:panelGrid>

        </h:panelGrid>

        <p:spacer height="10" width="0"/>

        <h:panelGrid>
            <p:commandButton value="Aceptar"
                             action="#{managedBeanParam.asociarProductosCatastralesDetallesAProductos}"
                             process="@form"
                             icon="ui-icon ui-icon-disk"
                             update="consultarPorDatosPersonaForm, msgsConsultarPorDatosPersona"
                             rendered="#{!managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}"
                             onstart="statusDialog2.show();"
                             oncomplete="statusDialog2.hide();">                
            </p:commandButton>

        </h:panelGrid>

        <p:spacer height="10" width="0"/>

        <p:fieldset toggleable="true" toggleSpeed="500"
                    id="personasAsociadasFS">
            <legend>
                <h:outputText value="Lista de personas asociadas al producto"
                              styleClass="legendTitle" />
            </legend>

            <p:dataTable emptyMessage="No hay personas asociadas al producto"
                         value="#{managedBeanParam.productosCatastralesDetallesAsociadasAProductos}"
                         var="personaAsociadaAProducto"
                         widgetVar="personasAsociadasAProductosDTWV"
                         rowKey="#{personaAsociadaAProducto.numeroIdentificacion}"
                         selection="#{managedBeanParam.productoCatastralDetalleSeleccionado}"
                         selectionMode="single"
                         id="personasAsociadasAProductosDT">

                <p:ajax event="rowSelect" process="@this"/>

                <p:ajax event="rowUnselect" process="@this"/>

                <f:facet name="header">
                    Lista de personas asociadas al producto
                </f:facet>

                <p:column rendered="#{!managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}">
                    <f:facet name="header">
                        Opciones
                    </f:facet>
                    <p:commandButton
                        action="#{managedBeanParam.eliminarProductosCatastralesDetallesAsociadasAProductos}"
                        icon="ui-icon ui-icon-trash"
                        title="Eliminar" id="eliminarProductoCatastralAsociado"
                        onstart="statusDialog2.show();"
                        oncomplete="statusDialog2.hide();"
                        update=":consultarPorDatosPersonaForm:personasAsociadasFS"
                        process="@this">
                        <f:setPropertyActionListener value="#{personaAsociadaAProducto}"
                                                     target="#{managedBeanParam.productoCatastralDetalleSeleccionado}" />
                    </p:commandButton>
                </p:column>

                <p:column headerText="Tipo persona" sortBy="#{personaAsociadaAProducto.tipoPersona}"
                          filterBy="#{personaAsociadaAProducto.tipoPersona}">
                    <h:outputText value="#{personaAsociadaAProducto.tipoPersona}" />
                </p:column>

                <p:column headerText="Tipo identificación" sortBy="#{personaAsociadaAProducto.tipoIdentificacion}"
                          filterBy="#{personaAsociadaAProducto.tipoIdentificacion}">
                    <h:outputText value="#{personaAsociadaAProducto.tipoIdentificacion}" />
                </p:column>

                <p:column headerText="No. identificación" sortBy="#{personaAsociadaAProducto.numeroIdentificacion}"
                          filterBy="#{personaAsociadaAProducto.numeroIdentificacion}">
                    <h:outputText value="#{personaAsociadaAProducto.numeroIdentificacion}" />
                </p:column>

                <p:column headerText="Nombre o razón social">
                    <h:outputText rendered="#{personaAsociadaAProducto.razonSocial eq null}"
                                  value="#{personaAsociadaAProducto.primerNombre} #{personaAsociadaAProducto.segundoNombre} 
                                  #{personaAsociadaAProducto.primerApellido} #{personaAsociadaAProducto.segundoApellido}" />

                    <h:outputText rendered="#{personaAsociadaAProducto.razonSocial ne null}"
                                  value="#{personaAsociadaAProducto.razonSocial}" />
                </p:column>

                <p:column headerText="Descripción trámite catastral">
                    <h:outputText value="#{personaAsociadaAProducto.tramiteCatastralDescripcion}" />
                </p:column>

                <p:column headerText="Depuración geográfica"
                          rendered="#{managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}">
                    <h:outputText value="#{personaAsociadaAProducto.depuracionGeoDescripcion}" />
                </p:column>

                <p:column headerText="Observaciones"
                          rendered="#{!managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}">
                    <h:outputText value="#{personaAsociadaAProducto.observaciones}" />
                </p:column>

            </p:dataTable>

            <p:spacer height="20" width="0"/>

            <h:panelGrid columns="2">

                <h:outputLabel value="Total propietarios"
                               styleClass="outputLabelStyle" />

                <h:outputLabel value="#{fn:length(managedBeanParam.productosCatastralesDetallesAsociadasAProductos)}"/>

                <p:commandButton value="Registrar inconsistencias"
                                 process="@this,personasAsociadasAProductosDT"
                                 icon="ui-icon ui-icon-disk"
                                 onstart="statusDialog2.show();"
                                 disabled="#{managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}"
                                 oncomplete="statusDialog2.hide();registrarInconsistenciasWV.show();"
                                 onclick="if (personasAsociadasAProductosDTWV.selection.length === 0) {
                                             alert('Debe seleccionar una persona asociada al producto!');
                                             return false;
                                         }"/>

            </h:panelGrid>

        </p:fieldset>

        <p:spacer height="10" width="0" />

        <h:panelGrid columns="5">

            <p:commandButton value="Enviar trámite catastral"
                             icon="ui-icon-seek-next"
                             onstart="statusDialog2.show();"
                             oncomplete="statusDialog2.hide();"
                             disabled="#{managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}"
                             process="@this"/>

            <p:spacer height="0" width="20" />

            <p:commandButton value="Generar producto"
                             icon="ui-icon ui-icon-disk"
                             process="@this"
                             onstart="statusDialog2.show();"
                             update=":registrarDatosPSForm"
                             rendered="#{!managedBeanParam.actividadRevisarInformacionDeProductosAGenerar}"
                             oncomplete="statusDialog2.hide();consultarPorDatosPersonaWV.hide();"
                             action="#{managedBeanParam.generarProducto}"/>

            <p:spacer height="0" width="20"/>		

            <p:commandButton value="Cerrar"
                             icon="ui-icon ui-icon-close"
                             oncomplete="consultarPorDatosPersonaWV.hide()"
                             process="@this"
                             action="#{managedBeanParam.cerrarDialogo}"
                             update = ":registrosPredialesForm, :registrosPredialesForm:departamentoYMunicipio, :registrarDatosPSForm"/>
        </h:panelGrid>	

    </p:fieldset>

</h:form>

